-- Credits to Snu for the sprite assets and part of the code here.
-- You deserve a pat on the back for everything you do.
-- Also Kanade is best waifu

-- weird flex ok

freeslot("MT_GGZFREEZETHRUSTER")
freeslot("SPR_GGZ6")

freeslot("S_GGZFREEZETHRUSTER")

-- skybox handler thing
freeslot("MT_FPZ_SKYBOX")
mobjinfo[MT_FPZ_SKYBOX] = {
	doomednum = 692,
	spawnstate = S_INVISIBLE,
	spawnhealth = 2,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	flags = MF_NOGRAVITY
}

-- falling snow:
-- "Snu, do you know any words that starts with the letter F?"
-- "Uh, Fsnu?"
-- "BRILLANT!"

freeslot("SPR_FSNU")


-- M-Muuuh... displayplayer too dangerous m-muh!!!!
local dp, c
hud.add(function(v, p, ca)
	dp = p
	c = ca
end)

-- skybox handler thinker
addHook("MobjThinker", function(mo)
	if not mo or not mo.valid return end
	if not mo.spawnpoint or not mo.spawnpoint.valid return end

	local can = (c and c.angle ~= nil) and c.angle or mo.angle

	local radius = mo.spawnpoint.angle
	-- due to how skyboxes work; we'll use dp's angle to know what how to display the weather.
	local special = mo.spawnpoint.options & MTF_OBJECTSPECIAL
	local an
	if not special
		an = (can - mo.angle) + ANG1*180	-- dp.mo might be nil because spectators, use cam angle instead
	else
		an = can + ANG1*180
	end

	for i = 1, (special and 4 or 8)
		local x = mo.x + P_RandomRange(-radius, radius)*mapobjectscale* (special and 2 or 1)
		local y = mo.y + P_RandomRange(-radius, radius)*mapobjectscale* (special and 2 or 1)
		local z = mo.ceilingz

		local s = P_SpawnMobj(x, y, z, MT_THOK)
		s.sprite = SPR_FSNU
		s.frame = B
		s.angle = an + ANG1*86
		P_InstaThrust(s, s.angle, P_RandomRange(24, 32)*mapobjectscale)
		s.scale = mapobjectscale/2 *(special and 2 or 1)
		s.momz = P_RandomRange(-45, -32)*mapobjectscale * (special and 2 or 1)
		s.tics = 35 / (special and 2 or 1)
	end
end, MT_FPZ_SKYBOX)

-- FrostThrower Stuff
mobjinfo[MT_GGZFREEZETHRUSTER] = {
	doomednum = 691,
	spawnstate = S_GGZFREEZETHRUSTER,
	spawnhealth = 1000,
	radius = 32*FRACUNIT,
	height = 48*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOCLIPTHING,
}
states[S_GGZFREEZETHRUSTER] = {SPR_GGZ6, A, -1, nil, 0, 0, S_GGZFREEZETHRUSTER}
