-- Makes backward orbis not decrease their speed after bumps

local function isBackward(mo)
    local input = mo.target.angle - mo.angle

    if input > ANGLE_180 then
        input = (ANGLE_MAX-input)+1
    end

    return abs(input/ANG1) > 30
end

addHook("MobjThinker", function(mo)
    if not (mo.valid and mo.health > 0) then return end
    if mo.backward == false then return end -- FINE i use "== false" because it is nil on first mobjthinker

    if mo.backward == nil then
        mo.backward = mo.target ~= nil and isBackward(mo)
    end

    if mo.realhealth == nil then
        mo.realhealth = mo.health
    end

    if mo.health < 7 then
        mo.health = 7
        mo.realhealth = $ - 1
    end

    if mo.realhealth == 0 then
        -- Gaaah i don't know why but it just despawns without proper animation
        S_StartSound(mo, mo.info.deathsound)
        P_KillMobj(mo)

        P_SetObjectMomZ(mo, 8*FRACUNIT, false)
        P_InstaThrust(mo, R_PointToAngle2(0, 0, mo.momx, mo.momy)+ANGLE_90, 16*FRACUNIT)

        mo.z = mo.z + mo.momz
    end
end, MT_ORBINAUT)
