addHook("MobjThinker", function(pmo)
    local flip = pmo.eflags & MFE_VERTICALFLIP

    if pmo.oldflip ~= nil and pmo.oldflip ~= flip then
        local mo = pmo.hnext

        while mo do
            if flip == 0 then
                mo.eflags = $ & ~MFE_VERTICALFLIP
            else
                mo.eflags = $ | MFE_VERTICALFLIP
            end

            mo = mo.hnext
        end
    end

    pmo.oldflip = flip
end, MT_PLAYER)
