-- TODO: How to tell if the sender is the dedicated server console?
--       isdedicatedserver is only set for the host
--       Lua doesn't expose the HU_SERVER_SAY flag

addHook("PlayerMsg", function(player, type, target, msg)
	-- find greentext
	local greentextStart = msg:find(">")
	if greentextStart == nil then return end

	local newmsg = msg:sub(1, greentextStart-1).."\x83"..msg:sub(greentextStart)

	local textcolor = player.spectator and "\x86" or "\x80"
	local name = "<"..player.name.."> "

	if type == 2 then -- sayto
		chatprintf(target, "\x82[PM]"..name..newmsg, true)
		if player ~= target then
			name = "<"..target.name.."> "
			chatprintf(player, "\x82[TO]"..name..textcolor..newmsg, true)
		end
		return true
	end

	local namecolor = player.spectator and "\x86" or SG_Color2Chat[player.skincolor]
	name = namecolor..player.name

	if player == server then
		name = "\x82~"..$
	elseif IsPlayerAdmin(player) then
		name = "\x82@"..$
	end

	if msg:find("/me ") == 1 then
		name = "* "..$.." "
		newmsg = $:sub(5)
	else
		name = namecolor.."<"..$.."> "
	end

	if type == 0 then -- say
		chatprint(name..textcolor..newmsg, true)
	elseif type == 1 then -- sayteam
		for target in players.iterate do
			if player.spectator == target.spectator then
				chatprintf(target, name..textcolor..newmsg, true)
			end
		end
	else -- csay (or unknown)
		return
	end

	return true
end)
