freeslot("sfx_spbska")

local cv_spbseeksound = CV_RegisterVar {
    name = "spbseeksound",
    defaultvalue = "On",
    possiblevalue = CV_OnOff,
}

sfxinfo[sfx_spbska].flags = $|SF_X8AWAYSOUND

local function seekSoundPlaying(mo)
    return S_SoundPlaying(mo, sfx_spbska)
end

local function stopSeekSound(mo)
    S_StopSoundByID(mo, sfx_spbska)
end

addHook("MobjThinker", function(mo)
    if not cv_spbseeksound.value then return end
    if not (mo.valid and mo.tracer) then return end

    local dist = FixedHypot(FixedHypot(mo.x-mo.tracer.x, mo.y-mo.tracer.y), mo.z-mo.tracer.z)
    local activeDist = 3072*mo.tracer.scale

    if dist > activeDist and mo.extravalue1 == 0 then
        if not seekSoundPlaying(mo) then
            S_StartSound(mo, sfx_spbska)
        end
    else
        stopSeekSound(mo)
    end
end, MT_SPB)
