-- Bumpspark + Nerf in one by Indev for Sunflower's Garden
-- Created because KMP has an annoying feature where hitting a wall kills all your drift speed, which isn't vanilla behaviour
-- Takes 1 line to fix, but not re-usable. Very cool.

local cv_bonkspark = CV_RegisterVar({
    name = "bonkspark",
    defaultvalue = "On",
    possiblevalue = CV_OnOff,
    flags = CV_NETVAR,
})

addHook("ThinkFrame", function()
    if not cv_bonkspark.value then return end

    for player in players.iterate do
        if player.mo then
            local pmo = player.mo

            if pmo.k_saveddriftcharge and player.kartstuff[k_driftcharge] == 0 and pmo.eflags & MFE_JUSTBOUNCEDWALL then
                player.kartstuff[k_driftend] = 0
                player.kartstuff[k_drift] = pmo.k_saveddrift
                player.kartstuff[k_driftcharge] = min(pmo.k_saveddriftcharge, K_GetKartDriftSparkValue(player))
            end

            pmo.k_saveddriftcharge = player.kartstuff[k_driftcharge]
            pmo.k_saveddrift = player.kartstuff[k_drift]
        end
    end
end)
