-- When enabled, orbis will bounce infinitely

local cv_enabled = CV_RegisterVar {
    name = "orbialwaysbounce",
    defaultvalue = "Off",
    possiblevalue = CV_OnOff,
    flags = CV_NETVAR,
}

addHook("MobjThinker", function(mo)
    if not mo.valid then return end
    if cv_enabled.value == 0 then return end
    if mo.health == 0 then return end -- Too late

    mo.health = max(mo.health, mobjinfo[mo.type].spawnhealth)
end, MT_ORBINAUT)
