-- Mine behaviour changes by Indev
-- tweak thoughts by AnimeSonic / Sunflower#1739
-- Mines will no longer arm when someone is in growth or invincible
-- Mines will no longer arm when someone is in i.frames
-- Former puts a stop on people 1 lap behind ruining your mines
-- Latter stop the nasty bahaviour of people putting mines after teleporters
--
-- v2: Due to complaints they will still explode when going through them now
function A_GrenadeRing(actor)
    local xl, xh, yl, yh

    local explodedist = FixedMul(actor.info.painchance, mapobjectscale)

    if actor.flags2 & MF2_DEBRIS then
        return
    end

    if actor.state == S_SSMINE_DEPLOY8 then
        explodedist = (3*explodedist)/2
    end

    if leveltime % 35 == 0 then
        S_StartSound(actor, actor.info.activesound)
    end

    for player in players.iterate do
        if not player.spectator then
            if R_PointToDist2(player.mo.x, player.mo.y, actor.x, actor.y) < explodedist
                and abs(player.mo.z - actor.z) < explodedist
                and not player.kartstuff[k_invincibilitytimer]
                and player.kartstuff[k_growshrinktimer] <= 0
                and not player.kartstuff[k_hyudorotimer]
                and not player.powers[pw_flashing]
                and not (G_BattleGametype() and player.kartstuff[k_bumper] <= 0 and player.kartstuff[k_comebacktimer]) then

                actor.state = actor.info.deathstate
                return
            end
        end
    end
end
