-- For rare cases when neoroulette rolls :c because of a bug

addHook("PlayerThink", function(p)
    if p.spectator then return end

    -- Only do on last tic of sad timer
    if p.kartstuff[k_sadtimer] == 1 then
        -- 4th and further places for sneaker is kinda arbitrary but hopefully will prevent getting sneaker when you're right next to 1st place
        -- (not that this script is supposed to ever trigger at all :p, if sad item is ever rolled thats a bug and it should be fixed instead)
        p.kartstuff[k_itemtype] = (K_IsPlayerLosing(p) and p.kartstuff[k_position] > 3) and KITEM_SNEAKER or KITEM_BANANA
        p.kartstuff[k_itemamount] = 1
    end
end)
