-- Make text gay colored

local CVAR_GayText = CV_RegisterVar(
    {
        name = "chat_rainbow_enabled",
        defaultvalue = "On",
        flags = CV_NETVAR,
        PossibleValue = CV_YesNo
    }
)

local function rainbow(str)
    local colors = {'\133', '\135', '\130', '\131', '\136', '\132', '\137'}
    local buff = {}
    local len = #str

    for i = 0, len-1 do
        table.insert(buff, colors[i % 7 + 1])
        table.insert(buff, str:sub(i+1, i+1))
    end

    return table.concat(buff, "")
end

addHook("PlayerMsg", function(player, type, target, msg)

	if CVAR_GayText.value == 0 then return end

    local gaytextStart = msg:find("!rb ")
	if gaytextStart == nil then return end

    msg = msg:gsub("!rb ", "")

    msg = rainbow(msg)
	
	local name = "<"..player.name.."> "
	
	if type == 2 then -- sayto
		chatprintf(target, "\x82[PM]"..name..msg, true)
		if player ~= target then
			name = "<"..target.name.."> "
			chatprintf(player, "\x82[TO]"..name..msg, true)
		end
		return true
	end

    local name = player.name
	local namecolor = player.spectator and "\x86" or SG_Color2Chat[player.skincolor]
	name = namecolor..name

    if player == server then
		name = "\x82~"..$
	elseif IsPlayerAdmin(player) then
		name = "\x82@"..$
	end

    name = namecolor.."<"..name.."> "

    if type == 0 then -- say
        chatprint(name..msg, true)
    end

    return true
end)
