-- Stole constants from paraglider lua haha
local PG_PLAYERMAXSTOREDFALL = 44*FRACUNIT
local PG_STORESPEEDTHRESHOLD = 4*PG_PLAYERMAXSTOREDFALL/5

local cv_fullvertcontrol = CV_RegisterVar({
	name = "paraglider_fullvertcontrol",
	defaultvalue = "Off",
	flags = CV_NETVAR|CV_CHEAT,
	PossibleValue = CV_OnOff,
})

local cv_fullhoryzontalcontrol = CV_RegisterVar({
	name = "paraglider_fullhoryzontalcontrol",
	defaultvalue = "Off",
	flags = CV_NETVAR|CV_CHEAT,
	PossibleValue = CV_OnOff,
})

addHook("MobjThinker", function(pmo)
    if cv_fullvertcontrol.value then
        pmo.storedGlideMomz = PG_STORESPEEDTHRESHOLD
    end

    if cv_fullhoryzontalcontrol.value and pmo.paragliding then
        local speed = FixedHypot(pmo.momx, pmo.momy)
        pmo.momx = FixedMul(cos(pmo.angle), speed)
        pmo.momy = FixedMul(sin(pmo.angle), speed)
    end
end, MT_PLAYER)
