COM_AddCommand("findskin", function(p, ...)
    local query = table.concat({...}, " "):lower()

    for i = 0, #skins-1 do
        local skin = skins[i]

        if skin then
            local name = skin.name:lower()
            local realname = skin.realname:lower()

            if name:find(query) or realname:find(query) then
                local colorchar = ''

                if SG_Color2Chat then colorchar = SG_Color2Chat[skin.prefcolor] end

                CONS_Printf(p, "\130"..skin.name.."\128 - "..colorchar..skin.realname)
            end
        end
    end
end, COM_LOCAL)
